Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3726)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3727)
@@ -892,25 +1299,55 @@
       IF ( dosurf_no(av) == 0 )  RETURN
 !
-!--   Open files
-      CALL check_open( 25+av )
-!
-!--   Write coordinates 
-      IF ( .NOT. first_output(av) )  THEN
-         DO  i = 0, io_blocks-1
-            IF ( i == io_group )  THEN
-               WRITE ( 25+av )  surfaces%npoints
-               WRITE ( 25+av )  surfaces%npoints_total
-               WRITE ( 25+av )  surfaces%ns
-               WRITE ( 25+av )  surfaces%ns_total
-               WRITE ( 25+av )  surfaces%points
-               WRITE ( 25+av )  surfaces%polygons
-            ENDIF
+!--   In case of VTK output, check if binary files are open and write coordinates. 
+      IF ( to_vtk )  THEN
+
+         CALL check_open( 25+av )
+
+         IF ( .NOT. first_output(av) )  THEN
+            DO  i = 0, io_blocks-1
+               IF ( i == io_group )  THEN
+                  WRITE ( 25+av )  surfaces%npoints
+                  WRITE ( 25+av )  surfaces%npoints_total
+                  WRITE ( 25+av )  surfaces%ns
+                  WRITE ( 25+av )  surfaces%ns_total
+                  WRITE ( 25+av )  surfaces%points
+                  WRITE ( 25+av )  surfaces%polygons
+               ENDIF
 #if defined( __parallel )
-            CALL MPI_BARRIER( comm2d, ierr )
+               CALL MPI_BARRIER( comm2d, ierr )
 #endif
-            first_output(av) = .TRUE.
-         ENDDO
+               first_output(av) = .TRUE.
+            ENDDO
+         ENDIF
       ENDIF
-
+!
+!--   In case of NetCDF output, check if enough time steps are available in file
+!--   and update time axis.
+      IF ( to_netcdf )  THEN
+         IF ( dosurf_time_count(av) + 1 > ntdim_surf(av) )  THEN
+            WRITE ( message_string, * ) 'Output of surface data is not given at t=',          &
+                                        time_since_reference_point, 's because the maximum ', & 
+                                        'number of output time levels is exceeded.'
+            CALL message( 'surface_data_output', 'PA0???', 0, 1, 0, 6, 0 )
+            
+            RETURN
+
+         ENDIF
+!
+!--      Update the netCDF time axis
+!--      In case of parallel output, this is only done by PE0 to increase the
+!--      performance.
+         dosurf_time_count(av) = dosurf_time_count(av) + 1
+         IF ( myid == 0 )  THEN
+            nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_time_surf(av),  &
+                                    (/ time_since_reference_point /),       &
+                                    start = (/ dosurf_time_count(av) /),    &
+                                    count = (/ 1 /) )
+            CALL netcdf_handle_error( 'surface_data_output', 6666 )
+         ENDIF
+      ENDIF
+
+!
+!--   Cycle through output quantities and write them to file.
       n_out = 0
       DO  WHILE ( dosurf(av,n_out+1)(1:1) /= ' ' )
@@ -2269,17 +2706,30 @@
 !--      - Dimension: 1-nsurfaces, 1-npoints - can be ordered consecutively
 !--      - Distinguish between average and non-average data
-         DO  i = 0, io_blocks-1
-            IF ( i == io_group )  THEN
-               WRITE ( 25+av )  LEN_TRIM( 'time' )
-               WRITE ( 25+av )  'time'
-               WRITE ( 25+av )  time_since_reference_point
-               WRITE ( 25+av )  LEN_TRIM( trimvar )
-               WRITE ( 25+av )  TRIM( trimvar )
-               WRITE ( 25+av )  surfaces%var_out
-            ENDIF
+         IF ( to_vtk )  THEN
+            DO  i = 0, io_blocks-1
+               IF ( i == io_group )  THEN
+                  WRITE ( 25+av )  LEN_TRIM( 'time' )
+                  WRITE ( 25+av )  'time'
+                  WRITE ( 25+av )  time_since_reference_point
+                  WRITE ( 25+av )  LEN_TRIM( trimvar )
+                  WRITE ( 25+av )  TRIM( trimvar )
+                  WRITE ( 25+av )  surfaces%var_out
+               ENDIF
 #if defined( __parallel )
-            CALL MPI_BARRIER( comm2d, ierr )
+               CALL MPI_BARRIER( comm2d, ierr )
 #endif
-         ENDDO
+            ENDDO
+         ENDIF
+         
+         IF ( to_netcdf )  THEN
+!
+!--         Write output array to file
+            nc_stat = NF90_PUT_VAR( id_set_surf(av), id_var_dosurf(av,n_out),            &
+                                    surfaces%var_out,                                    &
+                                    start = (/ surfaces%s(1), dosurf_time_count(av) /),  &
+                                    count = (/ surfaces%ns, 1 /) )
+            CALL netcdf_handle_error( 'surface_data_output', 6667 )
+         
+         ENDIF
 
       ENDDO
@@ -3553,5 +4003,6 @@
                                   averaging_interval_surf, data_output_surf,   &
                                   dt_dosurf, dt_dosurf_av,                     &
-                                  skip_time_dosurf, skip_time_dosurf_av
+                                  skip_time_dosurf, skip_time_dosurf_av,       &
+                                  to_netcdf, to_vtk
                                   
        line = ' '
@@ -3599,4 +4050,5 @@
 
        CHARACTER(LEN=100) ::  trimvar !< dummy for single output variable
+       CHARACTER(LEN=100) ::  unit    !< dummy for unit of output variable
 
        INTEGER(iwp) ::  av    !< id indicating average or non-average data output
@@ -3621,5 +4073,14 @@
                         'PA0087', 1, 2, 0, 6, 0 )
        ENDIF
-
+       
+#if ! defined( __netcdf4_parallel )
+!
+!--    Surface output via NetCDF requires parallel NetCDF
+       IF ( to_netcdf )  THEN
+          message_string = 'to_netcdf = .True. requires parallel NetCDF'
+          CALL message( 'surface_data_output_check_parameters',                &
+                        'PA0116', 1, 2, 0, 6, 0 )
+       ENDIF
+#endif
 !
 !--   Count number of output variables and separate output strings for 
@@ -3646,5 +4107,6 @@
 
 !
-!--      Check if all output variables are known
+!--      Check if all output variables are known and assign a unit
+         unit = 'not set'
          SELECT CASE ( TRIM( trimvar ) )
 
@@ -3655,31 +4117,49 @@
                              'PA0087', 1, 2, 0, 6, 0 )
 
-            CASE ( 'us', 'ts', 'qs', 'ss', 'qcs', 'ncs', 'qrs', 'nrs', 'ol' )
-
-            CASE ( 'z0', 'z0h', 'z0q' )
-
-            CASE ( 'theta1', 'qv1', 'thetav1' )
+            CASE ( 'us', 'uvw1' )
+               unit = 'm/s'
+
+            CASE ( 'ss', 'qcs', 'ncs', 'qrs', 'nrs' )
+               unit = '1'
+
+            CASE ( 'z0', 'z0h', 'z0q', 'ol' )
+               unit = 'm'
+
+            CASE ( 'ts', 'theta1', 'thetav1', 'theta_surface', 'thetav_surface' )
+               unit = 'K'
 
             CASE ( 'usws', 'vsws' )
+               unit = 'm2/s2'
             
-            CASE ( 'uvw1' )
-
             CASE ( 'qcsws', 'ncsws', 'qrsws', 'nrsws', 'sasws' )
 
-            CASE ( 'shf', 'qsws', 'ssws' )
-
-            CASE ( 'q_surface', 'theta_surface', 'thetav_surface' )
+            CASE ( 'shf' )
+               unit = 'K m/s'
+
+            CASE ( 'qsws' )
+               unit = 'kg/kg m/s'
+
+            CASE ( 'ssws' )
+               unit = 'kg/m2/s'
+
+            CASE ( 'qs', 'q_surface', 'qv1' )
+               unit = 'kg/kg'
 
             CASE ( 'rad_net' )
+               unit = 'W/m2'
 
             CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_lw_dif', 'rad_lw_ref',     &
                    'rad_lw_res' )
+               unit = 'W/m2'
 
             CASE ( 'rad_sw_in', 'rad_sw_out', 'rad_sw_dif', 'rad_sw_ref',     &
                    'rad_sw_res', 'rad_sw_dir' )
+               unit = 'W/m2'
 
             CASE ( 'ghf' )
+               unit = 'W/m2'
 
             CASE ( 'r_a', 'r_canopy', 'r_soil', 'r_s' )
+               unit = 's/m'
 
             CASE DEFAULT
@@ -3689,4 +4169,6 @@
                              'PA0087', 1, 2, 0, 6, 0 )
          END SELECT
+
+         dosurf_unit(av,dosurf_no(av)) = unit
 
        ENDDO
@@ -3717,17 +4199,20 @@
       IF ( dosurf_no(av) == 0 )  RETURN
 !
-!--   Open files
-      CALL check_open( 25+av )
-!
-!--   Write time coordinate
-      DO  i = 0, io_blocks-1
-         IF ( i == io_group )  THEN
-            WRITE ( 25+av )  LEN_TRIM( 'END' )
-            WRITE ( 25+av )  'END'
-         ENDIF
+!--   If output to VTK files is enabled, check if files are open and write
+!--   an end-of-file statement.
+      IF ( to_vtk )  THEN
+         CALL check_open( 25+av )
+!
+!--      Write time coordinate
+         DO  i = 0, io_blocks-1
+            IF ( i == io_group )  THEN
+               WRITE ( 25+av )  LEN_TRIM( 'END' )
+               WRITE ( 25+av )  'END'
+            ENDIF
 #if defined( __parallel )
-         CALL MPI_BARRIER( comm2d, ierr )
+            CALL MPI_BARRIER( comm2d, ierr )
 #endif
-      ENDDO    
+         ENDDO    
+      ENDIF
 
     END SUBROUTINE surface_data_output_last_action    
